import { App } from 'vue';
import { FusionAuthConfig } from './types.ts';
/**
 * Installation method for the FusionAuthVuePlugin.
 *
 * @category Plugin
 * @param {App} app - The Vue app instance.
 * @param {FusionAuthConfig} options - The configuration options for the plugin.
 * @throws {Error} Will throw an error if the required options are missing.
 */
declare const FusionAuthVuePlugin: {
    install(app: App, options: FusionAuthConfig): void;
};
export default FusionAuthVuePlugin;
export * from './components';
export * from './composables/useFusionAuth';
export * from './types';
