import { inject as y, defineComponent as l, openBlock as m, createElementBlock as R, renderSlot as h, createTextVNode as U, computed as E, createCommentVNode as w, unref as L, ref as f } from "vue";
const P = Symbol("fusionAuth"), g = () => {
  const r = y(P);
  if (!r)
    throw new Error(
      "No FusionAuth instance found. Did you forget to call Vue.use(FusionAuthVuePlugin)?"
    );
  return r;
}, x = /* @__PURE__ */ l({
  __name: "FusionAuthLoginButton",
  props: {
    state: {}
  },
  setup(r) {
    const t = g(), e = r;
    function o() {
      t.login(e.state);
    }
    return (s, n) => (m(), R("button", {
      class: "login-button",
      onClick: n[0] || (n[0] = (u) => o())
    }, [
      h(s.$slots, "default", {}, () => [
        U("Login")
      ], !0)
    ]));
  }
});
const v = (r, t) => {
  const e = r.__vccOpts || r;
  for (const [o, s] of t)
    e[o] = s;
  return e;
}, T = /* @__PURE__ */ v(x, [["__scopeId", "data-v-e1ac1678"]]), b = /* @__PURE__ */ l({
  __name: "FusionAuthLogoutButton",
  setup(r) {
    const t = g();
    function e() {
      t.logout();
    }
    return (o, s) => (m(), R("button", {
      class: "logout-button",
      onClick: s[0] || (s[0] = (n) => e())
    }, [
      h(o.$slots, "default", {}, () => [
        U("Logout")
      ], !0)
    ]));
  }
});
const C = /* @__PURE__ */ v(b, [["__scopeId", "data-v-fb8f3354"]]), S = /* @__PURE__ */ l({
  __name: "FusionAuthRegisterButton",
  props: {
    state: {}
  },
  setup(r) {
    const t = g(), e = r;
    function o() {
      t.register(e.state);
    }
    return (s, n) => (m(), R("button", {
      class: "register-button",
      onClick: n[0] || (n[0] = (u) => o())
    }, [
      h(s.$slots, "default", {}, () => [
        U("Register")
      ], !0)
    ]));
  }
});
const F = /* @__PURE__ */ v(S, [["__scopeId", "data-v-6adc2447"]]), $ = /* @__PURE__ */ l({
  __name: "RequireAuth",
  props: {
    withRole: {}
  },
  setup(r) {
    const t = r, { isLoggedIn: e, userInfo: o } = g(), s = E(() => {
      var d;
      if (!e.value || o.value === null)
        return !1;
      if (!t.withRole)
        return !0;
      const n = Array.isArray(t.withRole) ? t.withRole : [t.withRole], u = ((d = o.value) == null ? void 0 : d.roles) ?? [], a = e.value === !0, p = u.some((_) => n.includes(_));
      return a && p;
    });
    return (n, u) => s.value ? h(n.$slots, "default", { key: 0 }) : w("", !0);
  }
}), V = /* @__PURE__ */ l({
  __name: "RequireAnonymous",
  setup(r) {
    const { isLoggedIn: t } = g();
    return (e, o) => L(t) ? w("", !0) : h(e.$slots, "default", { key: 0 });
  }
}), B = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  FusionAuthLoginButton: T,
  FusionAuthLogoutButton: C,
  FusionAuthRegisterButton: F,
  RequireAnonymous: V,
  RequireAuth: $
}, Symbol.toStringTag, { value: "Module" }));
var H = Object.defineProperty, q = (r, t, e) => t in r ? H(r, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : r[t] = e, i = (r, t, e) => (q(r, typeof t != "symbol" ? t + "" : t, e), e);
class D {
  constructor(t) {
    i(this, "serverUrl"), i(this, "clientId"), i(this, "redirectUri"), i(this, "scope"), i(this, "mePath"), i(this, "loginPath"), i(this, "registerPath"), i(this, "logoutPath"), i(this, "tokenRefreshPath"), this.serverUrl = t.serverUrl, this.clientId = t.clientId, this.redirectUri = t.redirectUri, this.scope = t.scope, this.mePath = t.mePath ?? "/app/me", this.loginPath = t.loginPath ?? "/app/login", this.registerPath = t.registerPath ?? "/app/register", this.logoutPath = t.logoutPath ?? "/app/logout", this.tokenRefreshPath = t.tokenRefreshPath ?? "/app/refresh";
  }
  getMeUrl() {
    return this.generateUrl(this.mePath);
  }
  getLoginUrl(t) {
    return this.generateUrl(this.loginPath, {
      client_id: this.clientId,
      redirect_uri: this.redirectUri,
      scope: this.scope,
      state: t
    });
  }
  getRegisterUrl(t) {
    return this.generateUrl(this.registerPath, {
      client_id: this.clientId,
      redirect_uri: this.redirectUri,
      scope: this.scope,
      state: t
    });
  }
  getLogoutUrl() {
    return this.generateUrl(this.logoutPath, {
      client_id: this.clientId,
      post_logout_redirect_uri: this.redirectUri
    });
  }
  getTokenRefreshUrl() {
    return this.generateUrl(this.tokenRefreshPath, {
      client_id: this.clientId
    });
  }
  generateUrl(t, e) {
    const o = new URL(this.serverUrl);
    if (o.pathname = t, e) {
      const s = this.generateURLSearchParams(e);
      o.search = s.toString();
    }
    return o;
  }
  generateURLSearchParams(t) {
    const e = new URLSearchParams();
    return Object.entries(t).forEach(([o, s]) => {
      s && e.append(o, s);
    }), e;
  }
}
class j {
  constructor() {
    i(this, "REDIRECT_VALUE", "fa-sdk-redirect-value");
  }
  get storage() {
    try {
      return localStorage;
    } catch {
      return {
        /* eslint-disable */
        setItem(t, e) {
        },
        getItem(t) {
        },
        removeItem(t) {
        }
        /* eslint-enable */
      };
    }
  }
  handlePreRedirect(t) {
    const e = `${this.generateRandomString()}:${t ?? ""}`;
    this.storage.setItem(this.REDIRECT_VALUE, e);
  }
  handlePostRedirect(t) {
    const e = this.stateValue ?? void 0;
    t == null || t(e), this.storage.removeItem(this.REDIRECT_VALUE);
  }
  get didRedirect() {
    return !!this.storage.getItem(this.REDIRECT_VALUE);
  }
  get stateValue() {
    const t = this.storage.getItem(this.REDIRECT_VALUE);
    if (!t)
      return null;
    const [, ...e] = t.split(":");
    return e.join(":");
  }
  generateRandomString() {
    const t = new Uint32Array(28);
    return window.crypto.getRandomValues(t), Array.from(
      t,
      (e) => ("0" + e.toString(16)).substring(-2)
    ).join("");
  }
}
function O(r = "app.at_exp", t) {
  if (t)
    return A(t.at_exp(r));
  let e;
  try {
    e = document.cookie;
  } catch {
    return console.error(
      "Error accessing cookies in fusionauth. If you are using SSR you must configure the SDK with a cookie adapter"
    ), -1;
  }
  const o = e.split("; ").map((n) => n.split("=")).find(([n]) => n === r), s = o == null ? void 0 : o[1];
  return A(s);
}
function A(r) {
  return r ? Number(r) * 1e3 : -1;
}
class N {
  constructor(t) {
    i(this, "config"), i(this, "urlHelper"), i(this, "redirectHelper", new j()), i(this, "tokenExpirationTimeout"), this.config = t, this.urlHelper = new D({
      serverUrl: t.serverUrl,
      clientId: t.clientId,
      redirectUri: t.redirectUri,
      scope: t.scope,
      mePath: t.mePath,
      loginPath: t.loginPath,
      registerPath: t.registerPath,
      logoutPath: t.logoutPath,
      tokenRefreshPath: t.tokenRefreshPath
    }), this.scheduleTokenExpiration();
  }
  startLogin(t) {
    this.redirectHelper.handlePreRedirect(t), window.location.assign(this.urlHelper.getLoginUrl(t));
  }
  startRegister(t) {
    this.redirectHelper.handlePreRedirect(t), window.location.assign(this.urlHelper.getRegisterUrl(t));
  }
  startLogout() {
    window.location.assign(this.urlHelper.getLogoutUrl());
  }
  async fetchUserInfo() {
    const t = await fetch(this.urlHelper.getMeUrl(), {
      credentials: "include"
    });
    if (!t.ok)
      throw new Error(
        `Unable to fetch userInfo in fusionauth. Request failed with status code ${t == null ? void 0 : t.status}`
      );
    return await t.json();
  }
  async refreshToken() {
    const t = await fetch(this.urlHelper.getTokenRefreshUrl(), {
      method: "POST",
      credentials: "include",
      headers: {
        "Content-Type": "text/plain"
      }
    });
    if (!(t.status >= 200 && t.status < 300)) {
      const e = await (t == null ? void 0 : t.text()) || "Error refreshing access token in fusionauth";
      throw new Error(e);
    }
    return this.scheduleTokenExpiration(), t;
  }
  initAutoRefresh() {
    if (!this.isLoggedIn)
      return;
    const t = (this.config.autoRefreshSecondsBeforeExpiry ?? 10) * 1e3, e = (/* @__PURE__ */ new Date()).getTime(), o = this.at_exp - t, s = Math.max(o - e, 0);
    return setTimeout(async () => {
      var n, u;
      try {
        await this.refreshToken(), this.initAutoRefresh();
      } catch (a) {
        (u = (n = this.config).onAutoRefreshFailure) == null || u.call(n, a);
      }
    }, s);
  }
  handlePostRedirect(t) {
    this.isLoggedIn && this.redirectHelper.didRedirect && this.redirectHelper.handlePostRedirect(t);
  }
  get isLoggedIn() {
    return this.at_exp > (/* @__PURE__ */ new Date()).getTime();
  }
  /** The moment of access token expiration in milliseconds since epoch. */
  get at_exp() {
    return O(
      this.config.accessTokenExpireCookieName,
      this.config.cookieAdapter
    );
  }
  /** Schedules `onTokenExpiration` at moment of access token expiration. */
  scheduleTokenExpiration() {
    clearTimeout(this.tokenExpirationTimeout);
    const t = (/* @__PURE__ */ new Date()).getTime(), e = this.at_exp - t;
    e > 0 && (this.tokenExpirationTimeout = setTimeout(
      this.config.onTokenExpiration,
      e
    ));
  }
}
class M {
  constructor(t) {
    this.useCookie = t, this.useCookie = t;
  }
  at_exp(t = "app.at_exp") {
    return this.useCookie(t).value;
  }
}
const z = (r) => {
  let t;
  r.nuxtUseCookie && (t = new M(r.nuxtUseCookie));
  const e = new N({
    ...r,
    cookieAdapter: t,
    onTokenExpiration: () => {
      o.value = !1;
    }
  }), o = f(e.isLoggedIn), s = f(null), n = f(!1), u = f(null);
  async function a() {
    n.value = !0, u.value = null;
    try {
      return s.value = await e.fetchUserInfo(), s.value;
    } catch (c) {
      u.value = c;
    } finally {
      n.value = !1;
    }
  }
  async function p() {
    return await e.refreshToken();
  }
  function d() {
    return e.initAutoRefresh();
  }
  function _(c) {
    e.startLogin(c);
  }
  function I(c) {
    e.startRegister(c);
  }
  function k() {
    e.startLogout();
  }
  return r.shouldAutoFetchUserInfo && e.isLoggedIn === !0 && a(), r.shouldAutoRefresh && e.isLoggedIn === !0 && e.initAutoRefresh(), e.handlePostRedirect(r.onRedirect), {
    isLoggedIn: o,
    userInfo: s,
    getUserInfo: a,
    isGettingUserInfo: n,
    error: u,
    login: _,
    register: I,
    logout: k,
    refreshToken: p,
    initAutoRefresh: d
  };
}, G = {
  install(r, t) {
    if (!t.clientId)
      throw new Error("clientId is required");
    if (!t.serverUrl)
      throw new Error("serverUrl is required");
    if (!t.redirectUri)
      throw new Error("redirectUri is required");
    r.provide(P, z(t)), Object.entries(B).forEach(([e, o]) => {
      r.component(e, o);
    });
  }
};
export {
  T as FusionAuthLoginButton,
  C as FusionAuthLogoutButton,
  F as FusionAuthRegisterButton,
  V as RequireAnonymous,
  $ as RequireAuth,
  G as default,
  g as useFusionAuth
};
